#include <stdio.h>
#include <stdlib.h>
unsigned int xen_phys_start;

// stolen fom Xen 3.2.0
#define PML4_ENTRY_BITS  39
#define PML4_ENTRY_BYTES (1UL << PML4_ENTRY_BITS)
#define PML4_ADDR(_slot)                             \
    ((((_slot ## UL) >> 8) * 0xffff000000000000UL) | \
     (_slot ## UL << PML4_ENTRY_BITS))

/* Slot 261: machine-to-phys conversion table (16GB). */
#define RDWR_MPT_VIRT_START     (PML4_ADDR(261))
#define RDWR_MPT_VIRT_END       (RDWR_MPT_VIRT_START + (16UL<<30))
/* Slot 261: page-frame information array (16GB). */
#define FRAMETABLE_VIRT_START   (RDWR_MPT_VIRT_END)
#define FRAMETABLE_VIRT_END     (FRAMETABLE_VIRT_START + (16UL<<30))
/* Slot 261: ioremap()/fixmap area (16GB). */
#define IOREMAP_VIRT_START      (FRAMETABLE_VIRT_END)
#define IOREMAP_VIRT_END        (IOREMAP_VIRT_START + (16UL<<30))
/* Slot 261: compatibility machine-to-phys conversion table (1GB). */
#define RDWR_COMPAT_MPT_VIRT_START IOREMAP_VIRT_END
#define RDWR_COMPAT_MPT_VIRT_END (RDWR_COMPAT_MPT_VIRT_START + (1UL << 30))
/* Slot 261: high read-only compat machine-to-phys conversion table (1GB). */
#define HIRO_COMPAT_MPT_VIRT_START RDWR_COMPAT_MPT_VIRT_END
#define HIRO_COMPAT_MPT_VIRT_END (HIRO_COMPAT_MPT_VIRT_START + (1UL << 30))
/* Slot 261: xen text, static data and bss (1GB). */
#define XEN_VIRT_START          (HIRO_COMPAT_MPT_VIRT_END)
#define XEN_VIRT_END            (XEN_VIRT_START + (1UL << 30))
/* Slot 262-263: A direct 1:1 mapping of all of physical memory. */
#define DIRECTMAP_VIRT_START    (PML4_ADDR(262))
#define DIRECTMAP_VIRT_END      (DIRECTMAP_VIRT_START + PML4_ENTRY_BYTES*2)

static unsigned long __virt_to_maddr(unsigned long va)
{
    if ( va > DIRECTMAP_VIRT_START )
        return va - DIRECTMAP_VIRT_START;
    return va - XEN_VIRT_START + xen_phys_start;
}

main(int argc, char **argv)
{
	void *ret;
	unsigned long va;
	if (argc != 3) {
		fprintf(stderr, "%s: <xen_va> <xen_phys_start>\n", argv[0]);
		exit(1);
	}
	va = strtoul(argv[1], 0, 0);
	xen_phys_start = strtoul(argv[2], 0, 0);

	fprintf (stderr, "DIRECTMAP_VIRT_START  = %p\n", DIRECTMAP_VIRT_START);
	fprintf (stderr, "XEN_VIRT_START        = %p\n", XEN_VIRT_START);
	fprintf (stderr, "xen_phys_start        = %p\n", xen_phys_start);
	fprintf (stderr, "VIRT_START-phys_start = %p\n", XEN_VIRT_START + xen_phys_start);

	printf("%p\n",  __virt_to_maddr(va));

}
