#!/bin/bash
onesym()
{
LINE=`grep T" "$1\$ /proc/kallsyms`
if [ $? = 2 ] ; then 
	echo $0: grep error '?' 1>&2
	exit 1
fi
if [ "X""$LINE" = "X" ] ; then
	echo $0: $1 not found in /proc/kallsyms ?
	exit 1
else
	VAL=`echo $LINE | (read a b c; echo -n $a)`
fi
if ! ./mmapkmem 0x$VAL > code ; then
	exit 1
fi
if ! disas code length ; then
	exit 1
fi
echo -n "int "$1"_prefix=" >> $OUTFILE
cat length >> $OUTFILE
echo ';' >> $OUTFILE
}

if [ "X"$OUTFILE = "X" ] ; then echo OUTFILE not set ; exit 1; fi
PATH=../../devel:$PATH
cp /dev/null $OUTFILE
for i in $* ; do 
	onesym $i
done

